searchData={"content_type":"text/markdown","items":[{"doc":"BtrzAuth is the authentication api for the Betterez Elixir APIs.","ref":"BtrzAuth.html","title":"BtrzAuth","type":"module"},{"doc":"Generates an internal token using the configuration main or secondary secret keys.\n\nIt will return a token using the issuer passed by configuration and `%{}` claims.\n\nOptions:\n\n  * `issuer` - the issuer of the token\n  * `main_secret` - main secret key\n  * `secondary_secret` - secondary secret key","ref":"BtrzAuth.html#internal_auth_token/1","title":"BtrzAuth.internal_auth_token/1","type":"function"},{"doc":"Generates an user token using the configuration secret keys.\n\nOptions:\n\n  * `issuer` - the issuer of the token\n  * `secret` - secret key\n  * `claims` - custom claims for your token. Default %{}.","ref":"BtrzAuth.html#user_auth_token/2","title":"BtrzAuth.user_auth_token/2","type":"function"},{"doc":"","ref":"BtrzAuth.Audiences.html","title":"BtrzAuth.Audiences","type":"module"},{"doc":"","ref":"BtrzAuth.Audiences.html#valid_audiences/0","title":"BtrzAuth.Audiences.valid_audiences/0","type":"function"},{"doc":"","ref":"BtrzAuth.Audiences.html#valid_audiences_map/0","title":"BtrzAuth.Audiences.valid_audiences_map/0","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html","title":"BtrzAuth.Guardian.Plug","type":"module"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#authenticated?/2","title":"BtrzAuth.Guardian.Plug.authenticated?/2","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#clear_remember_me/2","title":"BtrzAuth.Guardian.Plug.clear_remember_me/2","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#current_claims/2","title":"BtrzAuth.Guardian.Plug.current_claims/2","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#current_resource/2","title":"BtrzAuth.Guardian.Plug.current_resource/2","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#current_token/2","title":"BtrzAuth.Guardian.Plug.current_token/2","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#implementation/0","title":"BtrzAuth.Guardian.Plug.implementation/0","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#put_current_claims/3","title":"BtrzAuth.Guardian.Plug.put_current_claims/3","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#put_current_resource/3","title":"BtrzAuth.Guardian.Plug.put_current_resource/3","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#put_current_token/3","title":"BtrzAuth.Guardian.Plug.put_current_token/3","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#put_session_token/3","title":"BtrzAuth.Guardian.Plug.put_session_token/3","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#remember_me/4","title":"BtrzAuth.Guardian.Plug.remember_me/4","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#remember_me_from_token/4","title":"BtrzAuth.Guardian.Plug.remember_me_from_token/4","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#sign_in/4","title":"BtrzAuth.Guardian.Plug.sign_in/4","type":"function"},{"doc":"","ref":"BtrzAuth.Guardian.Plug.html#sign_out/2","title":"BtrzAuth.Guardian.Plug.sign_out/2","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html","title":"BtrzAuth.GuardianUser.Plug","type":"module"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#authenticated?/2","title":"BtrzAuth.GuardianUser.Plug.authenticated?/2","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#clear_remember_me/2","title":"BtrzAuth.GuardianUser.Plug.clear_remember_me/2","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#current_claims/2","title":"BtrzAuth.GuardianUser.Plug.current_claims/2","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#current_resource/2","title":"BtrzAuth.GuardianUser.Plug.current_resource/2","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#current_token/2","title":"BtrzAuth.GuardianUser.Plug.current_token/2","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#implementation/0","title":"BtrzAuth.GuardianUser.Plug.implementation/0","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#put_current_claims/3","title":"BtrzAuth.GuardianUser.Plug.put_current_claims/3","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#put_current_resource/3","title":"BtrzAuth.GuardianUser.Plug.put_current_resource/3","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#put_current_token/3","title":"BtrzAuth.GuardianUser.Plug.put_current_token/3","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#put_session_token/3","title":"BtrzAuth.GuardianUser.Plug.put_session_token/3","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#remember_me/4","title":"BtrzAuth.GuardianUser.Plug.remember_me/4","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#remember_me_from_token/4","title":"BtrzAuth.GuardianUser.Plug.remember_me_from_token/4","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#sign_in/4","title":"BtrzAuth.GuardianUser.Plug.sign_in/4","type":"function"},{"doc":"","ref":"BtrzAuth.GuardianUser.Plug.html#sign_out/2","title":"BtrzAuth.GuardianUser.Plug.sign_out/2","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html","title":"BtrzAuth.Phoenix.Socket.Plug","type":"module"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#authenticated?/2","title":"BtrzAuth.Phoenix.Socket.Plug.authenticated?/2","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#clear_remember_me/2","title":"BtrzAuth.Phoenix.Socket.Plug.clear_remember_me/2","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#current_claims/2","title":"BtrzAuth.Phoenix.Socket.Plug.current_claims/2","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#current_resource/2","title":"BtrzAuth.Phoenix.Socket.Plug.current_resource/2","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#current_token/2","title":"BtrzAuth.Phoenix.Socket.Plug.current_token/2","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#implementation/0","title":"BtrzAuth.Phoenix.Socket.Plug.implementation/0","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#put_current_claims/3","title":"BtrzAuth.Phoenix.Socket.Plug.put_current_claims/3","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#put_current_resource/3","title":"BtrzAuth.Phoenix.Socket.Plug.put_current_resource/3","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#put_current_token/3","title":"BtrzAuth.Phoenix.Socket.Plug.put_current_token/3","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#put_session_token/3","title":"BtrzAuth.Phoenix.Socket.Plug.put_session_token/3","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#remember_me/4","title":"BtrzAuth.Phoenix.Socket.Plug.remember_me/4","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#remember_me_from_token/4","title":"BtrzAuth.Phoenix.Socket.Plug.remember_me_from_token/4","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#sign_in/4","title":"BtrzAuth.Phoenix.Socket.Plug.sign_in/4","type":"function"},{"doc":"","ref":"BtrzAuth.Phoenix.Socket.Plug.html#sign_out/2","title":"BtrzAuth.Phoenix.Socket.Plug.sign_out/2","type":"function"},{"doc":"InternalTokenToken will generate tokens for internal services authentication","ref":"BtrzAuth.Providers.InternalToken.html","title":"BtrzAuth.Providers.InternalToken","type":"module"},{"doc":"Gets a token with the internal options","ref":"BtrzAuth.Providers.InternalToken.html#get_token/1","title":"BtrzAuth.Providers.InternalToken.get_token/1","type":"function"},{"doc":"UserToken will generate tokens for users authentication","ref":"BtrzAuth.Providers.UserToken.html","title":"BtrzAuth.Providers.UserToken","type":"module"},{"doc":"Gets a token for the user with the options.\n\nOptions may include:\n * `secret` - secret key for generating your token.\n * `claims` - custom claims for your token. Default %{}.","ref":"BtrzAuth.Providers.UserToken.html#get_token/2","title":"BtrzAuth.Providers.UserToken.get_token/2","type":"function"},{"doc":"Looks for the `provider_ids` in the query params and fetchs its premium keys using account data under `conn.private.account`\nsaved by `BtrzAuth.Plug.VerifyApiKey` (the order of the plugs is very important!)\n\nThis plug will look for `providerId` or `provider_id` or a list of comma separated ids in `providerIds` or\n`provider_ids`.\n\nThis plug assumes that `BtrzAuth.Plug.VerifyProviders` already verified that the providers are valid for the account.\nIf the passed provider/s have premium keys, these will be added to the ones of the `conn.private.account`.\n\n#","ref":"BtrzAuth.Plug.AddPremiumFromProviders.html","title":"BtrzAuth.Plug.AddPremiumFromProviders","type":"module"},{"doc":"```elixir\nplug BtrzAuth.Plug.AddPremiumFromProviders\n\n```","ref":"BtrzAuth.Plug.AddPremiumFromProviders.html#module-example","title":"Example - BtrzAuth.Plug.AddPremiumFromProviders","type":"module"},{"doc":"","ref":"BtrzAuth.Plug.AddPremiumFromProviders.html#call/2","title":"BtrzAuth.Plug.AddPremiumFromProviders.call/2","type":"function"},{"doc":"","ref":"BtrzAuth.Plug.AddPremiumFromProviders.html#init/1","title":"BtrzAuth.Plug.AddPremiumFromProviders.init/1","type":"function"},{"doc":"Looks for and validates a token found in the `x-api-key` header requesting the accounts service to verify the token and saving the resource in `conn.private[:account]`.\n\nThis, like all other Guardian plugs, requires a Guardian pipeline to be setup.\nIt requires an error handler as `error_handler`.\n\nThese can be set either:\n\n1. Upstream on the connection with `plug Guardian.Pipeline`\n2. Upstream on the connection with `Guardian.Pipeline.{put_module, put_error_handler, put_key}`\n3. Inline with an option of `:module`, `:error_handler`, `:key`\n\nIf a token is found but is invalid, the error handler will be called with\n`auth_error(conn, {:api_key_not_found, reason})`\n\nOnce a token has been found, it will be matched against the database using the configured collection and property,\nif not found, the error handler will be called with\n`auth_error(conn, {:account_not_found, reason})`\n\nOptions:\n\n* `search_in` - atom. The places to look for the x-api-key (`:header`, `:query` or `:all`). Defaults to: `:all`\n* `allow_blank` - boolean. If set to true, will try to load a resource once the x-api-key is found, but will not fail if no resource is found. Defaults: false\n\n#","ref":"BtrzAuth.Plug.VerifyApiKey.html","title":"BtrzAuth.Plug.VerifyApiKey","type":"module"},{"doc":"```elixir\n\n# default search and verify in all (header and query string)\nplug BtrzAuth.Plug.VerifyApiKey\n# search only in header\nplug BtrzAuth.Plug.VerifyApiKey, search_in: :header\n\n```","ref":"BtrzAuth.Plug.VerifyApiKey.html#module-example","title":"Example - BtrzAuth.Plug.VerifyApiKey","type":"module"},{"doc":"","ref":"BtrzAuth.Plug.VerifyApiKey.html#call/2","title":"BtrzAuth.Plug.VerifyApiKey.call/2","type":"function"},{"doc":"","ref":"BtrzAuth.Plug.VerifyApiKey.html#init/1","title":"BtrzAuth.Plug.VerifyApiKey.init/1","type":"function"},{"doc":"Looks for and validates that the passed `audiences` are present in the private data under `conn.private.user_aud`\nsaved by `BtrzAuth.Plug.VerifyToken` (the order of the plugs is very important!)\n\nIf the audiences are invalid, the pipeline will be halted and the `conn.resp_body` with:\n\n```elixir\n%{\n  \"error\" => \"unauthorized\",\n  \"reason\" => \"audiences_not_verified\"\n}\n```\n\nOptions:\n\n* `audiences` - list of atom audiences to verify. Please use the ones found on BtrzAuth.Audiences.valid_audiences\n\n#","ref":"BtrzAuth.Plug.VerifyAudiences.html","title":"BtrzAuth.Plug.VerifyAudiences","type":"module"},{"doc":"```elixir\nplug BtrzAuth.Plug.VerifyAudiences, audiences: [:CUSTOMER]\n\n```","ref":"BtrzAuth.Plug.VerifyAudiences.html#module-example","title":"Example - BtrzAuth.Plug.VerifyAudiences","type":"module"},{"doc":"","ref":"BtrzAuth.Plug.VerifyAudiences.html#call/2","title":"BtrzAuth.Plug.VerifyAudiences.call/2","type":"function"},{"doc":"","ref":"BtrzAuth.Plug.VerifyAudiences.html#init/1","title":"BtrzAuth.Plug.VerifyAudiences.init/1","type":"function"},{"doc":"Looks for and validates that the passed `keys` features are present in the account data under `conn.private.account[\"premium\"]`\nsaved by `BtrzAuth.Plug.VerifyApiKey` (the order of the plugs is very important!)\n\nIf the premium keys are not found under `conn.private.account`, the pipeline will be halted and the `conn.resp_body` with:\n\n```elixir\n%{\n  \"error\" => \"unauthorized\",\n  \"reason\" => \"premium_not_verified\"\n}\n```\n\nOptions:\n\n* `keys` - list of atom premium features to verify. Defaults to: `[]`\n\n#","ref":"BtrzAuth.Plug.VerifyPremium.html","title":"BtrzAuth.Plug.VerifyPremium","type":"module"},{"doc":"```elixir\nplug BtrzAuth.Plug.VerifyPremium, keys: [:special_content]\n\n```","ref":"BtrzAuth.Plug.VerifyPremium.html#module-example","title":"Example - BtrzAuth.Plug.VerifyPremium","type":"module"},{"doc":"","ref":"BtrzAuth.Plug.VerifyPremium.html#call/2","title":"BtrzAuth.Plug.VerifyPremium.call/2","type":"function"},{"doc":"","ref":"BtrzAuth.Plug.VerifyPremium.html#init/1","title":"BtrzAuth.Plug.VerifyPremium.init/1","type":"function"},{"doc":"Looks for and validates if there are `provider_ids` in the query params and if they are valids with the account data under `conn.private.account`\nsaved by `BtrzAuth.Plug.VerifyApiKey` (the order of the plugs is very important!)\n\nThis plug will look for `providerId` or `provider_id` or a list of comma separated ids in `providerIds` or\n`provider_ids`.\n\nThis, like all other Guardian plugs, requires a Guardian pipeline to be setup.\nIt requires an error handler as `error_handler`.\n\nThese can be set either:\n\n1. Upstream on the connection with `plug Guardian.Pipeline`\n2. Upstream on the connection with `Guardian.Pipeline.{put_module, put_error_handler, put_key}`\n3. Inline with an option of `:module`, `:error_handler`, `:key`\n\nIf any provider is invalid, the pipeline will be halted and an error with status 400 will be set in the `conn.resp_body` like this:\n\n```elixir\n%{\n  \"status\" => 400,\n  \"code\" => \"INVALID_PROVIDER_ID\",\n  \"message\" => \"Error getting provider\"\n}\n```\n\n#","ref":"BtrzAuth.Plug.VerifyProviders.html","title":"BtrzAuth.Plug.VerifyProviders","type":"module"},{"doc":"```elixir\nplug BtrzAuth.Plug.VerifyProviders\n\n```","ref":"BtrzAuth.Plug.VerifyProviders.html#module-example","title":"Example - BtrzAuth.Plug.VerifyProviders","type":"module"},{"doc":"","ref":"BtrzAuth.Plug.VerifyProviders.html#call/2","title":"BtrzAuth.Plug.VerifyProviders.call/2","type":"function"},{"doc":"","ref":"BtrzAuth.Plug.VerifyProviders.html#init/1","title":"BtrzAuth.Plug.VerifyProviders.init/1","type":"function"},{"doc":"It depends on `BtrzAuth.Plug.VerifyApiKey`, looks for a token in the `Authorization` header and verify it using first the account's private key, if not valid, then main and secondary secrets provided by your app for internal token cases.\n\nIn the case where:\n\na. The session is not loaded\nb. A token is already found for `:key`\n\nThis plug will not do anything.\n\nThis, like all other Guardian plugs, requires a Guardian pipeline to be setup.\nIt requires an error handler.\n\nThese can be set either:\n\n1. Upstream on the connection with `plug Guardian.Pipeline`\n2. Upstream on the connection with `Guardian.Pipeline.{put_module, put_error_handler, put_key}`\n3. Inline with an option of `:module`, `:error_handler`, `:key`\n\nIf a token is found but is invalid, the error handler will be called with\n`auth_error(conn, {:invalid_token, reason})`\n\nOnce a token has been found it will be decoded, the token and claims will be put onto the connection.\n\nThey will be available using `Guardian.Plug.current_claims/2` and `Guardian.Plug.current_token/2`\n\nOptions:\n\n* `claims` - The literal claims to check to ensure that a token is valid\n* `realm` - The prefix for the token in the Authorization header. Defaults to `Bearer`. `:none` will not use a prefix.\n* `key` - The location to store the information in the connection. Defaults to: `default`\n\n#","ref":"BtrzAuth.Plug.VerifyToken.html","title":"BtrzAuth.Plug.VerifyToken","type":"module"},{"doc":"```elixir\n\n# setup the upstream pipeline\n\nplug BtrzAuth.Plug.VerifyHeaderInternal, claims: %{typ: \"access\"}\n\n```\n\nThis will check the authorization header for a token\n\n`Authorization Bearer:  `\n\nThis token will be placed into the connection depending on the key and can be accessed with\n`Guardian.Plug.current_token` and `Guardian.Plug.current_claims`\n\nOR\n\n`MyApp.ImplementationModule.current_token` and `MyApp.ImplementationModule.current_claims`","ref":"BtrzAuth.Plug.VerifyToken.html#module-example","title":"Example - BtrzAuth.Plug.VerifyToken","type":"module"},{"doc":"","ref":"BtrzAuth.Plug.VerifyToken.html#call/2","title":"BtrzAuth.Plug.VerifyToken.call/2","type":"function"},{"doc":"","ref":"BtrzAuth.Plug.VerifyToken.html#init/1","title":"BtrzAuth.Plug.VerifyToken.init/1","type":"function"},{"doc":"This pipeline will:\n1. Check the x-api-key header is sent and load the implemented resource in `conn.private[:account]`.\n2. Validate the providers if passed via query params.\n3. Add the premium keys of the providers to the ones of the current account.","ref":"BtrzAuth.Pipeline.ApiKeySecured.html","title":"BtrzAuth.Pipeline.ApiKeySecured","type":"module"},{"doc":"","ref":"BtrzAuth.Pipeline.ApiKeySecured.html#call/2","title":"BtrzAuth.Pipeline.ApiKeySecured.call/2","type":"function"},{"doc":"","ref":"BtrzAuth.Pipeline.ApiKeySecured.html#init/1","title":"BtrzAuth.Pipeline.ApiKeySecured.init/1","type":"function"},{"doc":"This pipeline will:\n1. Check the x-api-key header is sent and load the implemented resource in `conn.private[:account]`.\n2. Validate the providers if passed via query params.\n3. Add the premium keys of the providers to the ones of the current account.\n4. Verify the token with the private key or the configured main and secondary secret keys in case the token could be an internal one, then ensure authenticated.","ref":"BtrzAuth.Pipeline.TokenSecured.html","title":"BtrzAuth.Pipeline.TokenSecured","type":"module"},{"doc":"","ref":"BtrzAuth.Pipeline.TokenSecured.html#call/2","title":"BtrzAuth.Pipeline.TokenSecured.call/2","type":"function"},{"doc":"","ref":"BtrzAuth.Pipeline.TokenSecured.html#init/1","title":"BtrzAuth.Pipeline.TokenSecured.init/1","type":"function"},{"doc":"This module should be used only by Phoenix Sockets.","ref":"BtrzAuth.Phoenix.SocketAuth.html","title":"BtrzAuth.Phoenix.SocketAuth","type":"module"},{"doc":"Wraps the `Guardian.Phoenix.Socket.authenticate` using the `BtrzAuth.Phoenix.Socket` implementation module.","ref":"BtrzAuth.Phoenix.SocketAuth.html#authenticate/2","title":"BtrzAuth.Phoenix.SocketAuth.authenticate/2","type":"function"},{"doc":"","ref":"BtrzAuth.Services.Accounts.html","title":"BtrzAuth.Services.Accounts","type":"module"},{"doc":"","ref":"BtrzAuth.Services.Accounts.html#get_account_auth_info/2","title":"BtrzAuth.Services.Accounts.get_account_auth_info/2","type":"function"},{"doc":"# BtrzAuth\n\n[![Build status badge](https://img.shields.io/circleci/project/github/Betterez/btrz_ex_auth_api/master.svg)](https://circleci.com/gh/Betterez/btrz_ex_auth_api/tree/master)\n\nElixir package for authentication handling using Plug and Guardian (JWT).\nIt supports `X-API-KEY` token and `Authorization` tokens, for external users or internal API communication.","ref":"readme.html","title":"BtrzAuth","type":"extras"},{"doc":"API documentation at HexDocs [https://hexdocs.pm/btrz_ex_auth_api](https://hexdocs.pm/btrz_ex_auth_api)","ref":"readme.html#documentation","title":"Documentation - BtrzAuth","type":"extras"},{"doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `btrz_auth` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [{:btrz_ex_auth_api, \"~> 0.7.0\"}]\nend\n```\n\nAdd your configuration\n\n```elixir\nconfig :btrz_ex_auth_api, :token,\n    issuer: \"your-issuer\",\n    main_secret: \"YOUR_MAIN_KEY\",\n    secondary_secret: \"YOUR_SECONDARY_KEY\"\n```","ref":"readme.html#installation","title":"Installation - BtrzAuth","type":"extras"},{"doc":"You can use the [Guardian Plugs](https://hexdocs.pm/guardian/readme.html#plugs) and the ones added by BtrzAuth:\n\n#### `BtrzAuth.Plug.VerifyApiKey`\n\nLooks for the header or querystring `x-api-key` and verify the account, saving it into `conn.private[:account]`.\n\n#### `BtrzAuth.Plug.VerifyToken`\n\nIt depends on `BtrzAuth.Plug.VerifyApiKey`, looks for a token in the `Authorization` header and verify it using first the account's private key loading the user id in the `conn.private[:user_id]`, if not valid, then main and secondary secrets provided by your app for internal token cases.\n\n#### `BtrzAuth.Plug.VerifyPremium`\n\nLooks for and validates that the passed `keys` features are present in the account data under `conn.private.account[\"premium\"]`\nsaved by `BtrzAuth.Plug.VerifyApiKey` (the order of the plugs is very important!)","ref":"readme.html#plugs","title":"Plugs - BtrzAuth","type":"extras"},{"doc":"#","ref":"readme.html#pipelines","title":"Pipelines - BtrzAuth","type":"extras"},{"doc":"This pipeline will check the `x-api-key` header or querystring is sent and load the implemented resource in `conn.private[:account]`.\n\n* plug BtrzAuth.Plug.VerifyApiKey\n\n#","ref":"readme.html#btrzauth-pipeline-apikeysecured","title":"BtrzAuth.Pipeline.ApiKeySecured - BtrzAuth","type":"extras"},{"doc":"This pipeline will check the `x-api-key` header loading the account data in `conn.private[:account]` and also the token with the private key or the configured main and secondary secret keys in case the token could be an internal one, then ensure authenticated and load the implemented resource id in the `conn.private[:user_id]`.\n\n* plug BtrzAuth.Plug.VerifyApiKey\n* plug BtrzAuth.Plug.VerifyToken\n* plug Guardian.Plug.EnsureAuthenticated\n\nYou can add pipelines in your Phoenix Router to get different authentication working.\n\n```elixir\npipeline :token_secured do\n  plug BtrzAuth.Pipelines.TokenSecured\nend\n\nscope \"/\" do\n  pipe_through :token_secured\n  # your routes here...\nend\n```","ref":"readme.html#btrzauth-pipeline-tokensecured","title":"BtrzAuth.Pipeline.TokenSecured - BtrzAuth","type":"extras"},{"doc":"For Phoenix socket auth we wrap the `Guardian.Phoenix.Socket` module in order to use our `internal-token`, you might add to your `user_socket.ex`:\n\n```elixir\ndef connect(%{\"token\" => token}, socket) do\n  case BtrzAuth.Phoenix.SocketAuth.authenticate(socket, token) do\n    {:ok, authed_socket} ->\n      {:ok, authed_socket}\n    {:error, _} -> :error\n  end\nend\n\ndef connect(_params, _socket) do\n  :error\nend\n```","ref":"readme.html#phoenix-channels","title":"Phoenix Channels - BtrzAuth","type":"extras"},{"doc":"Add the test_resource in order to test your endpoints once the plugs or pipelines are defined:\n\n```elixir\nconfig :btrz_ex_auth_api, :token,\n    issuer: \"your-issuer\",\n    main_secret: \"YOUR_MAIN_KEY\",\n    secondary_secret: \"YOUR_SECONDARY_KEY\"\n    test_resource: %{account_id: \"DESIRED_ID\"}\n```\n\nand use `\"test-token\"` as your test token in the `Authorization` header.\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at [https://hexdocs.pm/btrz_auth](https://hexdocs.pm/btrz_auth).","ref":"readme.html#integration-tests-in-your-api","title":"Integration tests in your API - BtrzAuth","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}